=== debian/changelog ===
hypre (2.18.2-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.

 -- Drew Parsons <dparsons@debian.org>  Tue, 05 Nov 2019 02:27:52 +0900

hypre (2.18.1-1) experimental; urgency=medium

  * Team upload.
  * New upstream release.
  * Standards-Version: 4.4.1
  * Provide library binary package as libhypre without the soname
    version embedded in the package name. Enforce version dependency
    through strict shlibs dependency. This is to workaround lack of
    ABI backwards compatibility and keep minor version updates being
    delayed in the NEW queue. See README.Debian.

 -- Drew Parsons <dparsons@debian.org>  Sat, 26 Oct 2019 12:36:52 +0800

hypre (2.18.0-1exp1) experimental; urgency=medium

  * Team upload.
  * New upstream release.

 -- Drew Parsons <dparsons@debian.org>  Mon, 30 Sep 2019 10:51:22 +0800

hypre (2.17.0-1exp1) experimental; urgency=medium

  * Team upload.
  * New upstream release.
    - removed FEI_mv/ml subdirectory and several FEI header files
    - now dual licensed as Apache-2.0 OR MIT, at your option,
      instead of LGPL-2.1.
    - applies debian patch bootstrap-path.patch
  * use pkg-config to configure location of blas and lapack libraries

 -- Drew Parsons <dparsons@debian.org>  Sat, 24 Aug 2019 10:24:00 +0800
