=== debian/tests/control ===
Tests: test-hypre
Depends: @, @builddeps@
